# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ApiManagement::Mgmt::V2016_07_07
  module Models
    #
    # The Backend entity in API Management represents a backend service that is
    # configured to skip certification chain validation when using a
    # self-signed certificate to test mutual certificate authentication.
    #
    class BackendResponse < BackendContract

      include MsRestAzure

      # @return [String] Uniquely identifies the backend within the current API
      # Management service instance. The value is a valid relative URL in the
      # format of /backends/{backendId} where {backendId} is a backend
      # identifier.
      attr_accessor :id


      #
      # Mapper for BackendResponse class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BackendResponse',
          type: {
            name: 'Composite',
            class_name: 'BackendResponse',
            model_properties: {
              host: {
                client_side_validation: true,
                required: true,
                serialized_name: 'host',
                constraints: {
                  MaxLength: 255,
                  MinLength: 1
                },
                type: {
                  name: 'String'
                }
              },
              skip_certificate_chain_validation: {
                client_side_validation: true,
                required: false,
                serialized_name: 'skipCertificateChainValidation',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
