# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ApiManagement::Mgmt::V2016_10_10
  module Models
    #
    # Backend entity base Parameter set.
    #
    class BackendBaseParameters

      include MsRestAzure

      # @return [Array<String>] List of Client Certificate Thumbprint.
      attr_accessor :certificate

      # @return [Hash{String => Array<String>}] Query Parameter description.
      attr_accessor :query

      # @return [Hash{String => Array<String>}] Header Parameter description.
      attr_accessor :header

      # @return [String] WebProxy Server AbsoluteUri property which includes
      # the entire URI stored in the Uri instance, including all fragments and
      # query strings.
      attr_accessor :url

      # @return [String] Username to connect to the WebProxy server
      attr_accessor :username

      # @return [String] Password to connect to the WebProxy Server
      attr_accessor :password

      # @return [String] Backend Title.
      attr_accessor :title

      # @return [String] Backend Description.
      attr_accessor :description

      # @return [String] Management Uri of the Resource in External System.
      # This url can be the Arm Resource Id of Logic Apps, Function Apps or Api
      # Apps.
      attr_accessor :resource_id

      # @return [Boolean] Flag indicating whether SSL certificate chain
      # validation should be skipped when using self-signed certificates for
      # this backend host. Default value: false .
      attr_accessor :skip_certificate_chain_validation

      # @return [Boolean] Flag indicating whether SSL certificate name
      # validation should be skipped when using self-signed certificates for
      # this backend host. Default value: false .
      attr_accessor :skip_certificate_name_validation


      #
      # Mapper for BackendBaseParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BackendBaseParameters',
          type: {
            name: 'Composite',
            class_name: 'BackendBaseParameters',
            model_properties: {
              certificate: {
                client_side_validation: true,
                required: false,
                serialized_name: 'certificate',
                constraints: {
                  MaxItems: 32
                },
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              query: {
                client_side_validation: true,
                required: false,
                serialized_name: 'query',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ArrayElementType',
                      type: {
                        name: 'Sequence',
                        element: {
                            client_side_validation: true,
                            required: false,
                            serialized_name: 'StringElementType',
                            type: {
                              name: 'String'
                            }
                        }
                      }
                  }
                }
              },
              header: {
                client_side_validation: true,
                required: false,
                serialized_name: 'header',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ArrayElementType',
                      type: {
                        name: 'Sequence',
                        element: {
                            client_side_validation: true,
                            required: false,
                            serialized_name: 'StringElementType',
                            type: {
                              name: 'String'
                            }
                        }
                      }
                  }
                }
              },
              url: {
                client_side_validation: true,
                required: true,
                serialized_name: 'url',
                constraints: {
                  MaxLength: 2000,
                  MinLength: 1
                },
                type: {
                  name: 'String'
                }
              },
              username: {
                client_side_validation: true,
                required: false,
                serialized_name: 'username',
                type: {
                  name: 'String'
                }
              },
              password: {
                client_side_validation: true,
                required: false,
                serialized_name: 'password',
                type: {
                  name: 'String'
                }
              },
              title: {
                client_side_validation: true,
                required: false,
                serialized_name: 'title',
                constraints: {
                  MaxLength: 300,
                  MinLength: 1
                },
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                constraints: {
                  MaxLength: 2000,
                  MinLength: 1
                },
                type: {
                  name: 'String'
                }
              },
              resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceId',
                constraints: {
                  MaxLength: 2000,
                  MinLength: 1
                },
                type: {
                  name: 'String'
                }
              },
              skip_certificate_chain_validation: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.skipCertificateChainValidation',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              },
              skip_certificate_name_validation: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.skipCertificateNameValidation',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
