# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ApiManagement::Mgmt::V2018_01_01
  module Models
    #
    # Tenant Configuration Synchronization State.
    #
    class TenantConfigurationSyncStateContract

      include MsRestAzure

      # @return [String] The name of Git branch.
      attr_accessor :branch

      # @return [String] The latest commit Id.
      attr_accessor :commit_id

      # @return [Boolean] value indicating if last sync was save (true) or
      # deploy (false) operation.
      attr_accessor :is_export

      # @return [Boolean] value indicating if last synchronization was later
      # than the configuration change.
      attr_accessor :is_synced

      # @return [Boolean] value indicating whether Git configuration access is
      # enabled.
      attr_accessor :is_git_enabled

      # @return [DateTime] The date of the latest synchronization. The date
      # conforms to the following format: `yyyy-MM-ddTHH:mm:ssZ` as specified
      # by the ISO 8601 standard.
      #
      attr_accessor :sync_date

      # @return [DateTime] The date of the latest configuration change. The
      # date conforms to the following format: `yyyy-MM-ddTHH:mm:ssZ` as
      # specified by the ISO 8601 standard.
      #
      attr_accessor :configuration_change_date


      #
      # Mapper for TenantConfigurationSyncStateContract class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'TenantConfigurationSyncStateContract',
          type: {
            name: 'Composite',
            class_name: 'TenantConfigurationSyncStateContract',
            model_properties: {
              branch: {
                client_side_validation: true,
                required: false,
                serialized_name: 'branch',
                type: {
                  name: 'String'
                }
              },
              commit_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'commitId',
                type: {
                  name: 'String'
                }
              },
              is_export: {
                client_side_validation: true,
                required: false,
                serialized_name: 'isExport',
                type: {
                  name: 'Boolean'
                }
              },
              is_synced: {
                client_side_validation: true,
                required: false,
                serialized_name: 'isSynced',
                type: {
                  name: 'Boolean'
                }
              },
              is_git_enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'isGitEnabled',
                type: {
                  name: 'Boolean'
                }
              },
              sync_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'syncDate',
                type: {
                  name: 'DateTime'
                }
              },
              configuration_change_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'configurationChangeDate',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
