# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ApiManagement::Mgmt::V2019_12_01
  module Models
    #
    # Details of the Credentials used to connect to Backend.
    #
    class BackendCredentialsContract

      include MsRestAzure

      # @return [Array<String>] List of Client Certificate Thumbprint.
      attr_accessor :certificate

      # @return [Hash{String => Array<String>}] Query Parameter description.
      attr_accessor :query

      # @return [Hash{String => Array<String>}] Header Parameter description.
      attr_accessor :header

      # @return [BackendAuthorizationHeaderCredentials] Authorization header
      # authentication
      attr_accessor :authorization


      #
      # Mapper for BackendCredentialsContract class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BackendCredentialsContract',
          type: {
            name: 'Composite',
            class_name: 'BackendCredentialsContract',
            model_properties: {
              certificate: {
                client_side_validation: true,
                required: false,
                serialized_name: 'certificate',
                constraints: {
                  MaxItems: 32
                },
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              query: {
                client_side_validation: true,
                required: false,
                serialized_name: 'query',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ArrayElementType',
                      type: {
                        name: 'Sequence',
                        element: {
                            client_side_validation: true,
                            required: false,
                            serialized_name: 'StringElementType',
                            type: {
                              name: 'String'
                            }
                        }
                      }
                  }
                }
              },
              header: {
                client_side_validation: true,
                required: false,
                serialized_name: 'header',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ArrayElementType',
                      type: {
                        name: 'Sequence',
                        element: {
                            client_side_validation: true,
                            required: false,
                            serialized_name: 'StringElementType',
                            type: {
                              name: 'String'
                            }
                        }
                      }
                  }
                }
              },
              authorization: {
                client_side_validation: true,
                required: false,
                serialized_name: 'authorization',
                type: {
                  name: 'Composite',
                  class_name: 'BackendAuthorizationHeaderCredentials'
                }
              }
            }
          }
        }
      end
    end
  end
end
